/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
/**
 * hornet-js-react-components - Ensemble des composants web React de base de hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.2.1
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var test_run_1 = require("hornet-js-test/src/test-run");
var chai = require("chai");
var expect = chai.expect;
var React = require("react");
var hornet_react_test_1 = require("hornet-js-test/src/hornet-react-test");
var decorators_1 = require("hornet-js-test/src/decorators");
var assert = require("assert");
var checkbox_field_1 = require("hornet-js-react-components/src/widget/form/checkbox-field");
var formElement, switchField, checkboxElement;
var CheckBoxFieldTest = /** @class */ (function (_super) {
    tslib_1.__extends(CheckBoxFieldTest, _super);
    function CheckBoxFieldTest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CheckBoxFieldTest.prototype.beforeEach = function () {
        var _this = this;
        checkboxElement = (React.createElement(checkbox_field_1.CheckBoxField, { name: "test-checkbox", label: "Test-checkbox", ref: function (elt) { _this.checkboxElement = elt; } }));
        formElement = (React.createElement(checkbox_field_1.CheckBoxField, { name: "test-checkbox", readOnly: true, label: "Test-checkbox", ref: function (elt) { _this.checkbox = elt; } }));
        switchField = (React.createElement(checkbox_field_1.CheckBoxField, { name: "test-switch", readOnly: true, switch: true, label: "Test-checkbox", ref: function (elt) { _this.switch = elt; } }));
    };
    CheckBoxFieldTest.prototype.testOk = function () {
        assert.equal(1, 1);
        this.end();
    };
    CheckBoxFieldTest.prototype.testClick = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(checkboxElement, id);
        expect(document.querySelector("#" + id + " label.checkbox-content")).to.exist;
        expect(this.checkboxElement.getCurrentValue()).to.equal(false);
        // Clic sur la checkbox change la value
        this.triggerMouseEvent(document.querySelector("#" + id + " label.checkbox-content"), "click");
        setTimeout(function () {
            expect(_this.checkboxElement.getCurrentValue()).to.equal(true);
            // La touche entrée sur la checkbox change la value
            _this.triggerKeydownEvent(document.querySelector("#" + id + " label.checkbox-content"), "Enter", 13, true);
            setTimeout(function () {
                expect(_this.checkboxElement.getCurrentValue()).to.equal(false);
                _this.end();
            });
        });
    };
    CheckBoxFieldTest.prototype.testReadOnly = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(formElement, id);
        expect(document.querySelector("#" + id + " label.checkbox-content")).to.exist;
        expect(this.checkbox.getCurrentValue()).to.equal(false);
        // Clic sur la checkbox ne changera pas la value
        this.triggerMouseEvent(document.querySelector("#" + id + " label.checkbox-content"), "click");
        setTimeout(function () {
            expect(_this.checkbox.getCurrentValue()).to.equal(false);
            // La touche entrée sur la checkbox ne changera pas la value
            _this.triggerKeydownEvent(document.querySelector("#" + id + " label.checkbox-content"), "Enter", 13, true);
            setTimeout(function () {
                expect(_this.checkbox.getCurrentValue()).to.equal(false);
                _this.end();
            });
        });
    };
    CheckBoxFieldTest.prototype.testDisabled = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(formElement, id);
        this.checkbox.setState({ readOnly: false, disabled: true }, function () {
            expect(document.querySelector("#" + id + " label.checkbox-content")).to.exist;
            expect(_this.checkbox.getCurrentValue()).to.equal(false);
            // Clic sur la checkbox ne changera pas la value
            _this.triggerMouseEvent(document.querySelector("#" + id + " label.checkbox-content"), "click");
            setTimeout(function () {
                expect(_this.checkbox.getCurrentValue()).to.equal(false);
                // La touche entrée sur la checkbox ne changera pas la value
                _this.triggerKeydownEvent(document.querySelector("#" + id + " label.checkbox-content"), "Enter", 13, true);
                setTimeout(function () {
                    expect(_this.checkbox.getCurrentValue()).to.equal(false);
                    _this.end();
                });
            });
        });
    };
    CheckBoxFieldTest.prototype.testDisabledAndReadOnly = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(formElement, id);
        this.checkbox.setState({ readOnly: true, disabled: true }, function () {
            expect(document.querySelector("#" + id + " label.checkbox-content")).to.exist;
            expect(_this.checkbox.getCurrentValue()).to.equal(false);
            // Clic sur la checkbox ne changera pas la value
            _this.triggerMouseEvent(document.querySelector("#" + id + " label.checkbox-content"), "click");
            setTimeout(function () {
                expect(_this.checkbox.getCurrentValue()).to.equal(false);
                // La touche entrée sur la checkbox ne changera pas la value
                _this.triggerKeydownEvent(document.querySelector("#" + id + " label.checkbox-content"), "Enter", 13, true);
                setTimeout(function () {
                    expect(_this.checkbox.getCurrentValue()).to.equal(false);
                    _this.end();
                });
            });
        });
    };
    CheckBoxFieldTest.prototype.testReadOnlyOnSwitch = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(switchField, id);
        expect(document.querySelector("#" + id + " label.switch")).to.exist;
        expect(this.switch.getCurrentValue()).to.equal(false);
        // Clic sur la checkbox ne changera pas la value
        this.triggerMouseEvent(document.querySelector("#" + id + " label.switch"), "click");
        setTimeout(function () {
            expect(_this.switch.getCurrentValue()).to.equal(false);
            // La touche entrée sur la checkbox ne changera pas la value
            _this.triggerKeydownEvent(document.querySelector("#" + id + " label.switch"), "Enter", 13, true);
            setTimeout(function () {
                expect(_this.switch.getCurrentValue()).to.equal(false);
                _this.end();
            });
        });
    };
    CheckBoxFieldTest.prototype.testDisabledOnSwitch = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(switchField, id);
        this.switch.setState({ readOnly: false, disabled: true }, function () {
            expect(document.querySelector("#" + id + " label.switch")).to.exist;
            expect(_this.switch.getCurrentValue()).to.equal(false);
            // Clic sur la checkbox ne changera pas la value
            _this.triggerMouseEvent(document.querySelector("#" + id + " label.switch"), "click");
            setTimeout(function () {
                expect(_this.switch.getCurrentValue()).to.equal(false);
                // La touche entrée sur la checkbox ne changera pas la value
                _this.triggerKeydownEvent(document.querySelector("#" + id + " label.switch"), "Enter", 13, true);
                setTimeout(function () {
                    expect(_this.switch.getCurrentValue()).to.equal(false);
                    _this.end();
                });
            });
        });
    };
    CheckBoxFieldTest.prototype.testDisabledAndReadOnlyOnSwitch = function () {
        var _this = this;
        var id = this.generateMainId();
        this.renderIntoDocument(switchField, id);
        this.switch.setState({ readOnly: true, disabled: true }, function () {
            expect(document.querySelector("#" + id + " label.switch")).to.exist;
            expect(_this.switch.getCurrentValue()).to.equal(false);
            // Clic sur la checkbox ne changera pas la value
            _this.triggerMouseEvent(document.querySelector("#" + id + " label.switch"), "click");
            setTimeout(function () {
                expect(_this.switch.getCurrentValue()).to.equal(false);
                // La touche entrée sur la checkbox ne changera pas la value
                _this.triggerKeydownEvent(document.querySelector("#" + id + " label.switch"), "Enter", 13, true);
                setTimeout(function () {
                    expect(_this.switch.getCurrentValue()).to.equal(false);
                    _this.end();
                });
            });
        });
    };
    tslib_1.__decorate([
        decorators_1.Decorators.beforeEach,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "beforeEach", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test OK"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testOk", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test checkbox click"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testClick", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le checkbox est readOnly"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testReadOnly", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le checkbox est disabled"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testDisabled", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le checkbox est disabled et readOnly"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testDisabledAndReadOnly", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le switch est readOnly"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testReadOnlyOnSwitch", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le switch est disabled"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testDisabledOnSwitch", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test aucune action possible lorsque le switch est disabled et readOnly"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CheckBoxFieldTest.prototype, "testDisabledAndReadOnlyOnSwitch", null);
    CheckBoxFieldTest = tslib_1.__decorate([
        decorators_1.Decorators.describe("Test Karma checkbox-field")
    ], CheckBoxFieldTest);
    return CheckBoxFieldTest;
}(hornet_react_test_1.HornetReactTest));
// lancement des Tests
test_run_1.runTest(new CheckBoxFieldTest());

//# sourceMappingURL=checkbox-field.test.karma.js.map
